C
C     FFTE: A FAST FOURIER TRANSFORM PACKAGE
C
C     (C) COPYRIGHT SOFTWARE, 2000-2004, 2008-2014, ALL RIGHTS RESERVED
C                BY
C         DAISUKE TAKAHASHI
C         FACULTY OF ENGINEERING, INFORMATION AND SYSTEMS
C         UNIVERSITY OF TSUKUBA
C         1-1-1 TENNODAI, TSUKUBA, IBARAKI 305-8573, JAPAN
C         E-MAIL: daisuke@cs.tsukuba.ac.jp
C
C
C     DZFFT3D SPEED TEST PROGRAM
C
C     FORTRAN77 SOURCE PROGRAM
C
C     WRITTEN BY DAISUKE TAKAHASHI
C
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NDA=16777216)
      DIMENSION A(NDA),B(NDA)
      DIMENSION LNX(3),LNY(3),LNZ(3)
      SAVE A,B
C
      WRITE(6,*) ' NX,NY,NZ ='
      READ(5,*) NX,NY,NZ
      CALL FACTOR(NX,LNX)
      CALL FACTOR(NY,LNY)
      CALL FACTOR(NZ,LNZ)
C
      CALL INIT(A,NX*NY*NZ)
      CALL DZFFT3D(A,NX,NY,NZ,0,B)
      CALL DZFFT3D(A,NX,NY,NZ,-1,B)
      LOOP=1
C
!$ 10 CONTINUE
!$    TIME1=OMP_GET_WTIME()
      DO 20 I=1,LOOP
        CALL DZFFT3D(A,NX,NY,NZ,-1,B)
   20 CONTINUE
!$    TIME2=OMP_GET_WTIME()
!$    TIME0=TIME2-TIME1
!$    IF (TIME0 .LT. 1.0D0) THEN
!$      LOOP=LOOP*2
!$      GO TO 10
!$    END IF
!$    TIME0=TIME0/DBLE(LOOP)
!$    FLOPS=(2.5D0*DBLE(LNX(1)+LNY(1)+LNZ(1))
!$   1       +4.66666666666666D0*DBLE(LNX(2)+LNY(2)+LNZ(2))
!$   2       +6.8D0*DBLE(LNX(3)+LNY(3)+LNZ(3)))
!$   3       *DBLE(NX)*DBLE(NY)*DBLE(NZ)/TIME0/1.0D6
!$    WRITE(6,*) ' NX =',NX,' NY =',NY,' NZ =',NZ
!$    WRITE(6,*) ' TIME =',TIME0
!$    WRITE(6,*) FLOPS,' MFLOPS'
C
      STOP
      END
      SUBROUTINE INIT(A,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(*)
C
!$OMP PARALLEL DO
!DIR$ VECTOR ALIGNED
      DO 10 I=1,N
C        A(I)=DBLE(I)
        A(I)=(0.0D0,0.0D0)
   10 CONTINUE
      RETURN
      END
