C
C     FFTE: A FAST FOURIER TRANSFORM PACKAGE
C
C     (C) COPYRIGHT SOFTWARE, 2000-2004, 2008-2014, ALL RIGHTS RESERVED
C                BY
C         DAISUKE TAKAHASHI
C         FACULTY OF ENGINEERING, INFORMATION AND SYSTEMS
C         UNIVERSITY OF TSUKUBA
C         1-1-1 TENNODAI, TSUKUBA, IBARAKI 305-8573, JAPAN
C         E-MAIL: daisuke@cs.tsukuba.ac.jp
C
C
C     DZFFT3D AND ZDFFT3D TEST PROGRAM
C
C     FORTRAN77 SOURCE PROGRAM
C
C     WRITTEN BY DAISUKE TAKAHASHI
C
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NDA=16777216)
      DIMENSION A(NDA),B(NDA)
      SAVE A,B
C
      WRITE(6,*) ' NX,NY,NZ ='
      READ(5,*) NX,NY,NZ
C
      CALL INIT(A,NX*NY*NZ)
C
      CALL DZFFT3D(A,NX,NY,NZ,0,B)
      CALL DZFFT3D(A,NX,NY,NZ,-1,B)
      CALL DUMP(A,(NX/2+1)*NY*NZ)
C
      CALL ZDFFT3D(A,NX,NY,NZ,0,B)
      CALL ZDFFT3D(A,NX,NY,NZ,1,B)
      CALL RDUMP(A,NX*NY*NZ)
C
      STOP
      END
      SUBROUTINE INIT(A,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(*)
C
!$OMP PARALLEL DO
      DO 10 I=1,N
        A(I)=DBLE(I)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE DUMP(A,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(*)
C
      DO 10 I=1,N
        WRITE(6,*) I,A(I)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE RDUMP(A,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(*)
C
      DO 10 I=1,N
        WRITE(6,*) I,A(I)
   10 CONTINUE
      RETURN
      END
